/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "Transmission/SharedTextures/SharedTextureReceiver.h"

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Components/SceneComponent.h"
#include "Components/StaticMeshComponent.h"
#include "Materials/MaterialInstanceDynamic.h"

#include <string>

#include "ExpViewfinder.generated.h"

UCLASS(HideCategories = ("Actor", "HLOD", "Input"))
class MIXCAST_API AExpViewfinder : public AActor
{
	GENERATED_UCLASS_BODY()

public:
	std::string Identifier;

protected:
	UStaticMesh* PlaneMesh;

	SharedTextureReceiver* DisplayReceiver;	

	UPROPERTY()
		USceneComponent* ViewfinderTransform;
	UPROPERTY(VisibleAnywhere, Category = "Display")
		UStaticMeshComponent* DisplayMesh;
	UPROPERTY(VisibleAnywhere, Category = "Display")
		UMaterialInstanceDynamic* DisplayMat;

	void BeginPlay() override;
	void EndPlay(EEndPlayReason::Type EndPlayReason) override;
	void Tick(float DeltaSeconds) override;

	void HandleTextureChanged();
};
