/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "CoreMinimal.h"
#include "Engine/Engine.h"
#include "UObject/WeakObjectPtrTemplates.h"
#include "Components/SceneComponent.h"

#include "MixCastLightComponent.generated.h"

class ULightComponent;

UCLASS(HideCategories = ("Activation", "Actor", "Collision", "Cooking", "HLOD", "Input", "LOD", "Physics", "Rendering", "Replication", "Tags", "Asset User Data"),
	ClassGroup=(MixCast), meta=(BlueprintSpawnableComponent, DisplayName = "MixCast Light"))
class MIXCAST_API UMixCastLightComponent : public UActorComponent
{
	GENERATED_BODY()

public:	
	static TArray<UMixCastLightComponent*> Active;

	UMixCastLightComponent() {}

	ULightComponent* GetSource() { return source; }

protected:
	virtual void BeginPlay() override;
	virtual void EndPlay(const EEndPlayReason::Type EndPlayReason) override;

private:
	ULightComponent* source;
};
