/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#include "MixCast_Shaders.h"
#include "OcclusionShader.h"
#include "AlphaTransfer.h"

#include "Interfaces/IPluginManager.h"
#include "Containers/DynamicRHIResourceArray.h"
#include "Runtime/Renderer/Private/PostProcess/SceneRenderTargets.h"
#include "ShaderParameterUtils.h"

IMPLEMENT_MODULE(FMixCast_Shaders, MixCast_Shaders)

void FMixCast_Shaders::StartupModule()
{
#if UE_4_22_OR_LATER
	FString PluginShaderDir = FPaths::Combine(IPluginManager::Get().FindPlugin("MixCast")->GetBaseDir(), TEXT("Shaders"));
	AddShaderSourceDirectoryMapping(TEXT("/Plugin/MixCast"), PluginShaderDir);
#endif
}
void FMixCast_Shaders::ShutdownModule()
{

}

void FMixCast_Shaders::TransferAlpha(
	IRendererModule& RendererModule, 
	FRHICommandListImmediate& RHICmdList, 
	FSceneRenderTargets& SceneContext, 
	FSceneView& SceneView,
	UTextureRenderTarget2D& AlphaTarget)
{
	FMixCastAlphaTransfer::TransferAlpha(RendererModule, RHICmdList, SceneContext, SceneView, AlphaTarget);
}

#if MIXCAST_OCCLUDE_SCREENSPACE
void FMixCast_Shaders::RenderOcclusion(FRHICommandListImmediate& RHICmdList, FSceneView& InView, FRHITexture* DepthTextureRHI, float DepthMultiplierValue)
{
	FMixCastOcclusion::RenderOcclusion(RHICmdList, InView, DepthTextureRHI, DepthMultiplierValue);
}
#endif