/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once 

#include "MixCastDefines.h"

#include "CoreMinimal.h"
#include "Shader.h"
#include "SceneView.h"
#include "Modules/ModuleInterface.h"
#include "Modules/ModuleManager.h"

class MIXCAST_SHADERS_API FMixCast_Shaders : public IModuleInterface
{
public:
	static inline FMixCast_Shaders& Get()
	{
		return FModuleManager::LoadModuleChecked< FMixCast_Shaders >("MixCast_Shaders");
	}

	static inline bool IsAvailable()
	{
		return FModuleManager::Get().IsModuleLoaded("MixCast_Shaders");
	}

	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

	static void TransferAlpha(
		class IRendererModule& RendererModule, 
		FRHICommandListImmediate& RHICmdList, 
		class FSceneRenderTargets& SceneContext, 
		class FSceneView& SceneView,
		class UTextureRenderTarget2D& AlphaTarget);

#if MIXCAST_OCCLUDE_SCREENSPACE
	static void RenderOcclusion(FRHICommandListImmediate& RHICmdList, FSceneView& InView, FRHITexture* DepthTextureRHI, float DepthMultiplierValue);
#endif
};